/*
 * Nombre del proyecto: Proyecto Arkanoid
 *
 * Nombre del fichero: main.c
 *
 * Nombre de los autores: Grzegorz Adam Hankiewicz y Carlos Pereda Moreno
 *
 * Fecha: 18 de Enero del 2000
 *
 * Descripcin: Punto de entrada del juego. Se inicia la funcin main, y
 * sta pasa el control a otras.
 */

/* CABECERAS GLOBALES */
#ifdef MSS
#include <mss.h>
#endif MSS
#include <allegro.h>

/* CABECERAS DE FUNCIONES EXTERNAS */
#include "general.h"
#include "struct.h"
#include "errores.h"
#include "init.h"
#include "log.h"
#include "juego.h"

/* CABECERA PROPIA */
#define DECLARA_VARIABLES_MAIN_C
#include "main.h"


/**[txh]********************************************************************

  Description: Funcin principal de todo programa C. Esta funcin llama
  a inicializa_programa, que prepara el programa para ser ejecutado. Luego,
  pasa el control al bucle principal del juego. Cuando vuelve, finaliza el
  programa y se libera la memoria del juego.

  Return: (int) Cero con xito, otro valor si hubo algn fallo.

***************************************************************************/


int      main (int argc, char *argv[])
{
   int ret;

   /* Inicializacin. Si no devuelve cero, salimos del programa. */
   ret = inicializa_programa (argc, argv);
   if (ret || GET_FLAG (banderas, BIT_SHOW_HELP))
   {
      finaliza_programa();
      return ret;
   }

   lprintf ("Inicializacion completada. Comenzando juego.");
   
   ret = juego();
   
   /* Nos encargamos de cerrar el programa. */
   if (ret)
      lprintf ("El juego no se cerro adecuadamente. Valor de retorno %d", ret);
   else
      lprintf ("Cerrando programa por muerte natural en main()");
      
   finaliza_programa();
   return ret;
}
END_OF_MAIN();

